﻿@page "/program-detail/{PageModeName}"
@page "/program-detail/{PageModeName}/{Id:int}"

<PageTitle Title=@($"プログラム詳細({pageMode.DisplayValue})") />
<EditForm Model="@program" OnValidSubmit="OnValidSubmit" class="mt-2">
    <DataAnnotationsValidator />
    <MudCard>
        <MudCardContent>
            <TagInput @bind-AddedTags="AddedTags" Count="3" />
        </MudCardContent>
    </MudCard>

    @foreach (var addedTag in AddedTags)
    {
        <MudText>@addedTag</MudText>
    }
</EditForm>

@code {
    [Parameter]
    public string PageModeName { get; set; }

    [Parameter]
    public int Id { get; set; }

    private PageMode pageMode = new(1);
    private ProgramEntity program = new();

    private IEnumerable<SystemCompartmentEntity> systemCompartments = new List<SystemCompartmentEntity>();
    private IEnumerable<SubSystemCompartmentEntity> subSystemCompartments = new List<SubSystemCompartmentEntity>();

    public List<string> AddedTags = new();

    protected override void OnParametersSet()
    {
        pageMode = new(PageModeName);
    }

    protected async override Task OnInitializedAsync()
    {
        systemCompartments = await HttpClient.GetFromJsonAsync<List<SystemCompartmentEntity>>($"api/SystemCompartments");
        subSystemCompartments = await HttpClient.GetFromJsonAsync<List<SubSystemCompartmentEntity>>($"api/SubSystemCompartments");

        if (Id != 0)
        {
            try
            {
                program = await HttpClient.GetFromJsonAsync<ProgramEntity>($"api/Programs/{Id}");
            }
            catch (Exception ex)
            {
                Snackbar.Add(ex.Message, Severity.Success);
            }
        }
    }

    private async Task OnValidSubmit(EditContext context)
    {
        try
        {
            if (pageMode == PageMode.Create)
            {
                await HttpClient.PostAsJsonAsync<ProgramEntity>("api/SubSystemCompartments", program);
            }
            else if (pageMode == PageMode.Edit)
            {
                await HttpClient.PutAsJsonAsync<ProgramEntity>($"api/SubSystemCompartments/{Id}", program);
            }
            else if (pageMode == PageMode.Delete)
            {
                await HttpClient.DeleteAsync($"api/SubSystemCompartments/{Id}");
            }
        }
        catch (Exception)
        {
            throw;
        }

        NavigationManager.NavigateTo("/subsystem-compartment-list");
        StateHasChanged();
    }

}